extends Node2D

var net_worth: Big

# Called when the node enters the scene tree for the first time.
func _ready() -> void:
	_on_microgame_spawn_timer_timeout()
	net_worth = Big.new(1000)
	
	var window = get_window()
	window.position = Vector2(450, 360)
	window.size = Vector2(1319, 300)

# Called every frame. 'delta' is the elapsed time since the previous frame.
func _process(delta: float) -> void:
	# The most important functionality
	if Input.is_action_just_pressed("G"):
		$Meow.play()
		
	$Score.text = "Net worth: \n$%s" % net_worth.toString()


func _on_microgame_spawn_timer_timeout() -> void:
	print("WAAAHAHAHA MICROGAMES")
	
	# Spawn a microgame window
	var window_scene = preload("res://scenes/microgames/ad/ad_window.tscn")
	var window_instance = window_scene.instantiate()
	add_child(window_instance)
	
	# Randomize window position
	var screen_size = DisplayServer.screen_get_size()
	var window_x = randi_range(0, screen_size.x - window_instance.size.x)
	var window_y = randi_range(0, screen_size.y - window_instance.size.y)
	window_instance.position = Vector2(window_x, window_y)
	
	# Connect signals
	window_instance.win.connect(_on_microgame_win)
	

func _on_microgame_win(window: MicrogameWindow):
	print("yay")


func _on_stock_ticker_buy(amount: Variant) -> void:
	net_worth = net_worth.minus(amount)


func _on_stock_ticker_sell(amount: Variant) -> void:
	net_worth = net_worth.plus(amount)
